
#ifndef M3D_BAREMODEL_HPP
#define M3D_BAREMODEL_HPP

#include "Grid.hpp"
#include "util/VirtuallyDestructed.hpp"
#include "Settings.hpp"

namespace M3D {

struct Operation;

class BareModel : public VirtuallyDestructed
{
  Grid grid_;
  GridSettings settings_;
    // Invariant: settings_ apply to grid_

  public:

    explicit BareModel (GridSettings const &);
    GridSettings const & gridSettings () const { return settings_; }
    Grid const & grid () const { return grid_; }
    virtual void apply (Operation const &) {}
      // Todo: Either apply NVI or explain why it's not appropriate (I suspect that NVI is awkward for deeper hierarchies where every class that implements the function calls the base version).
};

} // namespace M3D

#endif // header guard
