
#ifndef M3D_FIELDDRAWERS_HPP
#define M3D_FIELDDRAWERS_HPP

#include <boost/shared_ptr.hpp>
#include <gtkmm.h>
#include "util/color.hpp"

namespace M3D {

struct FieldShape;

struct FieldDrawer
{
  struct Implementation;

  explicit FieldDrawer (Implementation const *);
  FieldDrawer (FieldDrawer const &);
  FieldDrawer & operator= (FieldDrawer const &);
  ~FieldDrawer ();

  void draw (FieldShape const &, float magnification) const;
  float radius (FieldShape const &, float magnification) const;
  bool suitableForDisplayList () const;

  private:

    boost::shared_ptr<Implementation const> pimpl;
};

extern FieldDrawer const nullFieldDrawer;

FieldDrawer solidFieldDrawer (Glib::RefPtr<Gdk::Pixbuf>);
FieldDrawer spriteFieldDrawer (Glib::RefPtr<Gdk::Pixbuf>, float magnification);

} // namespace M3D

#endif // header guard
