
#include "Operations.hpp"
#include "ObservedModel.hpp"
#include "Observers.hpp"

namespace M3D {

Operation * OpenOperation::inverse (ObservedModel const &) const
{
  OpenOperation * const r = new OpenOperation ;
  r->field = field;
  r->opened = !opened;
  return r;
}

Operation * FlagOperation::inverse (ObservedModel const & model) const
{
  FlagOperation * const r = new FlagOperation;
  r->field = field;
  r->flagLevel = M3D::flagLevel(model)[field];
  return r;
}

void restart (ObservedModel & m, TimeoutTimer const & t)
{
  m.apply(RestartOperation(t));
}

} // namespace M3D
