
#ifndef UTIL_CLONABLE_HPP
#define UTIL_CLONABLE_HPP

template <typename Interface, typename Derived = void>
struct Clonable;

template <typename Interface>
class Clonable<Interface, void>
{
  virtual Interface * vclone () const = 0;

  public:

    Interface * clone () const
    {
      Interface * const r = this->vclone();
      assert(typeid(*r) == typeid(*this));
      return r;
    }

    virtual ~Clonable () {}
};

template <typename Interface, typename Derived>
class Clonable : public virtual Clonable<Interface>
{
  Interface * vclone () const { return new Derived(*static_cast<Derived const *>(this)); }
    // Unfortunately we can't return Derived* here, because this is not a "valid" covariant return type situation.
};

#endif // header guard
