
#ifndef UTIL_EQUALITYCOMPARABLE_HPP
#define UTIL_EQUALITYCOMPARABLE_HPP

template <typename Derived = void> struct EqualityComparable;

template <>
struct EqualityComparable<void>
{
  virtual bool equal (EqualityComparable const & other) const = 0;
  virtual ~EqualityComparable () {}
};

template <typename Derived>
class EqualityComparable : public virtual EqualityComparable<>
{
  bool equal (EqualityComparable<> const & other) const
  {
    if (Derived const * const p = dynamic_cast<Derived const *>(&other))
      return *static_cast<Derived const *>(this) == *p;
    else return false;
  }
};

#endif // header guard
