
#ifndef UTIL_TIMEOUTTIMER_HPP
#define UTIL_TIMEOUTTIMER_HPP

#include <exception>

#include <boost/timer.hpp>
#include <boost/shared_ptr.hpp>

class TimeoutTimer
{
  boost::shared_ptr<boost::timer> timer;
  double timeout;

  public:

    struct Exception : std::exception
    {
      char const * what () const throw () { return "timeout"; }
    };

    explicit TimeoutTimer (double const t) : timer (new boost::timer), timeout (t) {}
    void check () const { if (timer->elapsed() > timeout) throw Exception(); }
};

#endif // header guard
