
#ifndef UTIL_COLOR_HPP
#define UTIL_COLOR_HPP

#include <boost/array.hpp>
#include <boost/static_assert.hpp>

struct RGBAcolor : boost::array<unsigned char, 4>
{
  unsigned char & r () { return elems[0]; }
  unsigned char & g () { return elems[1]; }
  unsigned char & b () { return elems[2]; }
  unsigned char & a () { return elems[3]; }
  unsigned char const & r () const { return elems[0]; }
  unsigned char const & g () const { return elems[1]; }
  unsigned char const & b () const { return elems[2]; }
  unsigned char const & a () const { return elems[3]; }

  RGBAcolor () {}

  RGBAcolor (unsigned char const r,
             unsigned char const g,
             unsigned char const b,
             unsigned char const a)
  {
    elems[0] = r;
    elems[1] = g;
    elems[2] = b;
    elems[3] = a;
  }
};

struct RGBcolor : boost::array<unsigned char, 3>
{
  unsigned char & r () { return elems[0]; }
  unsigned char & g () { return elems[1]; }
  unsigned char & b () { return elems[2]; }
  unsigned char const & r () const { return elems[0]; }
  unsigned char const & g () const { return elems[1]; }
  unsigned char const & b () const { return elems[2]; }

  RGBcolor (RGBAcolor const & c)
  {
    elems[0] = c.r();
    elems[1] = c.g();
    elems[2] = c.b();
  }

  RGBcolor (unsigned char const r,
            unsigned char const g,
            unsigned char const b)
  {
    elems[0] = r;
    elems[1] = g;
    elems[2] = b;
  }

  RGBcolor () {}
};

BOOST_STATIC_ASSERT(sizeof(RGBcolor) == 3);
BOOST_STATIC_ASSERT(sizeof(RGBAcolor) == 4);

#endif // header guard
