
#ifndef UTIL_ENUM_DEFINITION_HPP
#define UTIL_ENUM_DEFINITION_HPP

#include <boost/preprocessor.hpp>

#define DEFINE_WRAPPED_ENUM_H0(e) BOOST_PP_SEQ_ELEM(0, e) = BOOST_PP_SEQ_ELEM(1, e)
#define DEFINE_WRAPPED_ENUM_H1(e) BOOST_PP_SEQ_ELEM(0, e)
#define DEFINE_WRAPPED_ENUM_H2(s, data, elem) \
  BOOST_PP_IF( \
   BOOST_PP_DEC(BOOST_PP_SEQ_SIZE(elem)), \
   DEFINE_WRAPPED_ENUM_H0, DEFINE_WRAPPED_ENUM_H1 \
  )(elem)

#define DEFINE_WRAPPED_ENUM_H3(x, data, elem) \
  f(BOOST_PP_SEQ_ELEM(0, elem), BOOST_PP_STRINGIZE(BOOST_PP_SEQ_ELEM(0, elem)));

#define DEFINE_WRAPPED_ENUM(name, vals)                                                             \
  struct name {                                                                                     \
    enum enum_type { BOOST_PP_SEQ_ENUM(BOOST_PP_SEQ_TRANSFORM(DEFINE_WRAPPED_ENUM_H2, ~, vals)) };  \
    private:                                                                                        \
      typedef void wrapped_enum_tag;                                                                \
      enum_type value;                                                                              \
    public:                                                                                         \
      template <typename F>                                                                         \
      static void values (F & f) { BOOST_PP_SEQ_FOR_EACH(DEFINE_WRAPPED_ENUM_H3, name, vals) }      \
      name () {}                                                                                    \
      name (enum_type const v) : value (v) {}                                                       \
      operator enum_type () const { return value; }                                                 \
      friend bool operator== (name const & a, name const & b) { return a.value == b.value; }        \
      friend bool operator== (enum_type const a, name const & b) { return a == b.value; }           \
      friend bool operator== (name const & a, enum_type const b) { return a.value == b; }           \
  };

#endif // header guard
