
#ifndef UTIL_ENUM_SERIALIZATION_SYMBOLS_HPP
#define UTIL_ENUM_SERIALIZATION_SYMBOLS_HPP

#include "serialization-symbols.hpp"

template <typename E>
struct EnumSerializationSymbolGenerator
{
  typename ::serialization_symbols<E>::type r;
  void operator() (E const e, char const * const s) { r.insert(std::make_pair(e, s)); }
  typename ::serialization_symbols<E>::type generate () { E::values(*this); return r; }
};

#define ENUM_SERIALIZATION_SYMBOLS(name) \
  template <typename Pod, name (Pod:: * M)> \
  serialization_symbols<HighlightStyle>::type make_serialization_symbols ( \
    SerializationSymbolOverloadTag<name, Pod, M>) \
  { return EnumSerializationSymbolGenerator<name>().generate(); }
  // works regardless of POD type

#endif // header guard
