
#ifndef UTIL_GLADEMM_HPP
#define UTIL_GLADEMM_HPP

#include <gtkmm.h>
#include <libglademm.h>

#include <stdexcept> // runtime_error
#include <string>

template <typename T>
T & get (Glib::RefPtr<Gnome::Glade::Xml> const & p, std::string const & s)
{
  T * r = 0;
  p->get_widget(s, r);
  if (!r) throw std::runtime_error("could not get widget: " + s);
  return *r;
}

template <typename T>
T & get_derived (Glib::RefPtr<Gnome::Glade::Xml> const & p, std::string const & s)
{
  T * r = 0;
  p->get_widget_derived(s, r);
  if (!r) throw std::runtime_error("could not get widget: " + s);
  return *r;
}

#endif // header guard
