
#ifndef POD_EQUALITY_HPP
#define POD_EQUALITY_HPP

#include "PodIteratorBase.hpp"

template <typename Pod>
struct PodEqualityComparer : PodIteratorBase<PodEqualityComparer<Pod>, Pod>
{
  Pod const & l, & r;

  bool result;

  template <typename T, T (Pod::* M)>
  bool process (char const /* name */ []) { return (result = l.*M == r.*M); }

  PodEqualityComparer (Pod const & l_, Pod const & r_) : l (l_), r (r_) {}
};

#define POD_DEFINE_EQUALITY(Pod)                         \
  inline bool operator== (Pod const & l, Pod const & r)  \
  {                                                      \
    PodEqualityComparer<Pod> c (l, r);                   \
    pod_members(c, OverloadTag<Pod>());                  \
    return c.result;                                     \
  }                                                      \
                                                         \
  inline bool operator!= (Pod const & l, Pod const & r)  \
  { return !(l == r); }

#endif // header guard
